=== debian/changelog ===
xrootd-s3-http (0.5.3-1) unstable; urgency=medium

  * Update to version 0.5.3

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 29 Oct 2025 09:26:27 +0100
