=== debian/control ===
Source: xrootd-s3-http
Section: net
Priority: optional
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 nlohmann-json3-dev,
 libxrootd-server-dev,
 libcurl4-openssl-dev,
 libssl-dev,
 libtinyxml2-dev,
 libgtest-dev,
 curl,
 openssl,
 procps,
 xrootd-server
Homepage: https://github.com/PelicanPlatform/xrootd-s3-http
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/xrootd-s3-http
Vcs-Git: https://salsa.debian.org/ellert/xrootd-s3-http.git

Package: xrootd-s3-http
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 xrootd-server,
 ${shlibs:Depends},
 ${misc:Depends}
Description: S3/HTTP filesystem plugins for XRootD
 These filesystem plugins for XRootD allow you to serve objects from S3
 and HTTP backends through an XRootD server.
