## xrootd-s3-http 0.6.0

=== debian/changelog ===
xrootd-s3-http (0.6.0-1) unstable; urgency=medium

  * Update to version 0.6.0

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 12 Jan 2026 15:30:19 +0100
