## xrootd-s3-http 0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -91,38 +91,51 @@
 #
 add_definitions( -D_FILE_OFFSET_BITS=64 )
 
+set(PelicanHttpCoreSources
+  src/CurlUtil.cc
+  src/HTTPCommands.cc
+  src/TokenFile.cc
+  src/stl_string_utils.cc
+  src/shortfile.cc
+  src/logging.cc)
+
+add_library(XrdPelicanHttpCore SHARED ${PelicanHttpCoreSources})
+set_target_properties(XrdPelicanHttpCore PROPERTIES POSITION_INDEPENDENT_CODE ON)
+target_include_directories(XrdPelicanHttpCore PRIVATE ${XRootD_INCLUDE_DIRS})
+target_link_libraries(XrdPelicanHttpCore ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl OpenSSL::Crypto tinyxml2::tinyxml2 Threads::Threads std::filesystem std::atomic)
+
 ######################
 ##  libXrdOssS3     ##
 ######################
 # On Linux, we hide all the symbols for the final libraries, exposing only what's needed for the XRootD
 # runtime loader.  So here we create the object library and will create a separate one for testing with
 # the symbols exposed.
-add_library(XrdS3Obj OBJECT src/CurlUtil.cc src/S3File.cc src/S3Directory.cc src/S3AccessInfo.cc src/S3FileSystem.cc src/AWSv4-impl.cc src/S3Commands.cc src/HTTPCommands.cc src/TokenFile.cc src/stl_string_utils.cc src/shortfile.cc src/logging.cc)
+add_library(XrdS3Obj OBJECT src/S3File.cc src/S3Directory.cc src/S3AccessInfo.cc src/S3FileSystem.cc src/AWSv4-impl.cc src/S3Commands.cc)
 set_target_properties(XrdS3Obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_include_directories(XrdS3Obj PRIVATE ${XRootD_INCLUDE_DIRS})
 target_link_libraries( XrdS3Obj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl OpenSSL::Crypto tinyxml2::tinyxml2 Threads::Threads std::filesystem std::atomic )
 
 # Compatability library, doesn't match upstream's naming convention
 add_library(XrdS3 MODULE "$<TARGET_OBJECTS:XrdS3Obj>")
-target_link_libraries(XrdS3 XrdS3Obj)
+target_link_libraries(XrdS3 XrdS3Obj XrdPelicanHttpCore)
 # New library name, matches upstream's naming convention
 add_library(XrdOssS3 MODULE "$<TARGET_OBJECTS:XrdS3Obj>")
-target_link_libraries(XrdOssS3 XrdS3Obj)
+target_link_libraries(XrdOssS3 XrdS3Obj XrdPelicanHttpCore)
 
 ######################
 ##  libXrdOssHTTP   ##
 ######################
-add_library(XrdHTTPServerObj OBJECT src/CurlUtil.cc src/HTTPFile.cc src/HTTPDirectory.cc src/HTTPFileSystem.cc src/HTTPCommands.cc src/TokenFile.cc src/stl_string_utils.cc src/shortfile.cc src/logging.cc)
+add_library(XrdHTTPServerObj OBJECT src/HTTPFile.cc src/HTTPDirectory.cc src/HTTPFileSystem.cc)
 set_target_properties(XrdHTTPServerObj PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_include_directories(XrdHTTPServerObj PRIVATE ${XRootD_INCLUDE_DIRS})
 target_link_libraries(XrdHTTPServerObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl  tinyxml2::tinyxml2 OpenSSL::Crypto Threads::Threads std::filesystem)
 
 # Compatability library, doesn't match upstream's naming convention
 add_library(XrdHTTPServer MODULE "$<TARGET_OBJECTS:XrdHTTPServerObj>")
-target_link_libraries(XrdHTTPServer XrdHTTPServerObj)
+target_link_libraries(XrdHTTPServer XrdHTTPServerObj XrdPelicanHttpCore)
 # New library name, matches upstream's naming convention
 add_library(XrdOssHttp MODULE "$<TARGET_OBJECTS:XrdHTTPServerObj>")
-target_link_libraries(XrdOssHttp XrdHTTPServerObj)
+target_link_libraries(XrdOssHttp XrdHTTPServerObj XrdPelicanHttpCore)
 
 ######################
 ## libXrdOssFilter  ##
@@ -138,13 +151,13 @@
 ######################
 ## libXrdOssGlobus  ##
 ######################
-add_library(XrdOssGlobusObj OBJECT src/HTTPCommands.cc src/GlobusFile.cc src/GlobusFileSystem.cc src/GlobusDirectory.cc src/logging.cc src/stl_string_utils.cc src/shortfile.cc src/TokenFile.cc src/CurlUtil.cc)
+add_library(XrdOssGlobusObj OBJECT src/GlobusFile.cc src/GlobusFileSystem.cc src/GlobusDirectory.cc)
 set_target_properties(XrdOssGlobusObj PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_include_directories(XrdOssGlobusObj PRIVATE ${XRootD_INCLUDE_DIRS})
 target_link_libraries(XrdOssGlobusObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} nlohmann_json::nlohmann_json CURL::libcurl OpenSSL::Crypto Threads::Threads std::filesystem)
 
 add_library(XrdOssGlobus MODULE "$<TARGET_OBJECTS:XrdOssGlobusObj>")
-target_link_libraries(XrdOssGlobus XrdOssGlobusObj)
+target_link_libraries(XrdOssGlobus XrdOssGlobusObj XrdPelicanHttpCore)
 
 #######################
 ## libXrdOssPosc     ##
@@ -156,8 +169,20 @@
 add_library( XrdOssPosc MODULE "$<TARGET_OBJECTS:XrdOssPoscObj>" )
 target_link_libraries( XrdOssPosc XrdOssPoscObj )
 
+#######################
+## libXrdN2NPrefix   ##
+#######################
+add_library( XrdN2NPrefixObj OBJECT src/PrefixN2N.cc )
+set_target_properties( XrdN2NPrefixObj PROPERTIES POSITION_INDEPENDENT_CODE ON )
+target_include_directories( XrdN2NPrefixObj PRIVATE ${XRootD_INCLUDE_DIRS} )
+target_link_libraries( XrdN2NPrefixObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} nlohmann_json::nlohmann_json )
+
+add_library( XrdN2NPrefix MODULE "$<TARGET_OBJECTS:XrdN2NPrefixObj>" )
+target_link_libraries( XrdN2NPrefix XrdN2NPrefixObj )
+
 # Customize module's suffix and, on Linux, hide unnecessary symbols
 if( APPLE )
+  set_target_properties( XrdPelicanHttpCore PROPERTIES OUTPUT_NAME "XrdPelicanHttpCore-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
@@ -165,7 +190,9 @@
   set_target_properties( XrdOssFilter PROPERTIES OUTPUT_NAME "XrdOssFilter-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdOssGlobus PROPERTIES OUTPUT_NAME "XrdOssGlobus-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdOssPosc PROPERTIES OUTPUT_NAME "XrdOssPosc-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
+  set_target_properties( XrdN2NPrefix PROPERTIES OUTPUT_NAME "XrdN2NPrefix-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
 else()
+  set_target_properties( XrdPelicanHttpCore PROPERTIES OUTPUT_NAME "XrdPelicanHttpCore-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
@@ -173,66 +200,28 @@
   set_target_properties( XrdOssFilter PROPERTIES OUTPUT_NAME "XrdOssFilter-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdOssGlobus PROPERTIES OUTPUT_NAME "XrdOssGlobus-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdOssPosc PROPERTIES OUTPUT_NAME "XrdOssPosc-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
+  set_target_properties( XrdN2NPrefix PROPERTIES OUTPUT_NAME "XrdN2NPrefix-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
+  #set_target_properties( XrdOfsRedirect PROPERTIES OUTPUT_NAME "XrdOfsRedirect-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-ofs-lib-symbols" )
 endif()
 
 include(GNUInstallDirs)
 
 install(
-  TARGETS XrdS3 XrdHTTPServer XrdOssS3 XrdOssHttp XrdOssFilter XrdOssGlobus XrdOssPosc
+  TARGETS XrdPelicanHttpCore XrdS3 XrdHTTPServer XrdOssS3 XrdOssHttp XrdOssFilter XrdOssGlobus XrdOssPosc XrdN2NPrefix
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
 )
 
 if( ENABLE_TESTS )
   # Create shared libraries for testing from the existing objects
   add_library(XrdS3Testing SHARED "$<TARGET_OBJECTS:XrdS3Obj>")
-  target_link_libraries(XrdS3Testing XrdS3Obj)
+  target_link_libraries(XrdS3Testing XrdS3Obj XrdPelicanHttpCore)
   target_include_directories(XrdS3Testing INTERFACE ${XRootD_INCLUDE_DIRS})
 
   add_library(XrdHTTPServerTesting SHARED "$<TARGET_OBJECTS:XrdHTTPServerObj>")
-  target_link_libraries(XrdHTTPServerTesting XrdHTTPServerObj)
+  target_link_libraries(XrdHTTPServerTesting XrdHTTPServerObj XrdPelicanHttpCore)
   target_include_directories(XrdHTTPServerTesting INTERFACE ${XRootD_INCLUDE_DIRS})
 
   add_library( XrdOssFilterTesting SHARED "$<TARGET_OBJECTS:XrdOssFilterObj>" )
   target_link_libraries( XrdOssFilterTesting XrdOssFilterObj )
   target_include_directories( XrdOssFilterTesting INTERFACE ${XRootD_INCLUDE_DIRS} )
 
-  add_library(XrdOssGlobusTesting SHARED "$<TARGET_OBJECTS:XrdOssGlobusObj>")
-  target_link_libraries(XrdOssGlobusTesting XrdOssGlobusObj)
-  target_include_directories(XrdOssGlobusTesting INTERFACE ${XRootD_INCLUDE_DIRS})
-
-  add_library( XrdOssPoscTesting SHARED "$<TARGET_OBJECTS:XrdOssPoscObj>" )
-  target_link_libraries( XrdOssPoscTesting XrdOssPoscObj )
-  target_include_directories( XrdOssPoscTesting INTERFACE ${XRootD_INCLUDE_DIRS} )
-
-  find_program(GoWrk go-wrk HINTS "$ENV{HOME}/go/bin")
-  if( NOT GoWrk )
-    # Try installing the go-wrk variable to generate a reasonable stress test
-    execute_process( COMMAND go install github.com/bbockelm/go-wrk@92dbe19
-      RESULT_VARIABLE go_install_result )
-    if( go_install_result EQUAL 0 )
-      find_program(GoWrk go-wrk HINTS "$ENV{HOME}/go/bin")
-    else()
-      message( WARNING "Failed to install the go-wrk binary" )
-    endif()
-  endif()
-
-  if( NOT XROOTD_PLUGINS_EXTERNAL_GTEST )
-    include( FetchContent )
-    set( GTEST_URL "${CMAKE_CURRENT_SOURCE_DIR}/googletest-1.15.2.tar.gz" )
-    if( NOT EXISTS "${GTEST_URL}" )
-        set( GTEST_URL "https://github.com/google/googletest/releases/download/v1.15.2/googletest-1.15.2.tar.gz" )
-    endif()
-    cmake_policy(SET CMP0135 NEW)
-    FetchContent_Declare(GTest
-      URL "${GTEST_URL}"
-      URL_HASH SHA256=7b42b4d6ed48810c5362c265a17faebe90dc2373c885e5216439d37927f02926
-      TEST_COMMAND ""
-    )
-    FetchContent_MakeAvailable( GTest )
-  else()
-    find_package(GTest REQUIRED)
-  endif()
-
-  enable_testing()
-  add_subdirectory(test)
-endif()
