=== debian/changelog ===
xrootd-s3-http (0.6.1-1) unstable; urgency=medium

  * Update to version 0.6.1

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 20 Jan 2026 16:52:29 +0100
