=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: xrootd-s3-http
 Section: net
-Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -29,6 +28,6 @@
  xrootd-server,
  ${shlibs:Depends},
  ${misc:Depends}
-Description: S3/HTTP filesystem plugins for XRootD
+Description: S3/HTTP/Globus filesystem plugins for XRootD
  These filesystem plugins for XRootD allow you to serve objects from S3
  and HTTP backends through an XRootD server.
