## xrootd-s3-http 0.6.3

=== debian/changelog ===
xrootd-s3-http (0.6.3-1) unstable; urgency=medium

  * Update to version 0.6.3
  * Drop patches - accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 28 Jan 2026 12:55:11 +0100
