=== debian/changelog ===
xrootd-s3-http (0.6.4-1) unstable; urgency=medium

  * Update to version 0.6.4

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 10 Feb 2026 17:00:01 +0100
