=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,8 @@
 
 override_dh_auto_test:
 	# s3 tests require network (https://s3.us-east-1.amazonaws.com)
-	# posc tests fail when run in parallel:
-	# https://github.com/PelicanPlatform/xrootd-s3-http/issues/111
-	dh_auto_test -- ARGS+="-E 'S3|s3|TestPosc'"
+	dh_auto_test -- ARGS+="-E 'S3|s3'"
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
+	rm debian/tmp/usr/lib/*/libXrdPelicanHttpCore.so
